=== debian/changelog ===
prjtrellis (1.4-2) unstable; urgency=medium

  * Source-only upload to allow testing migration, no changes.

 -- Simon Richter <sjr@debian.org>  Fri, 10 Nov 2023 00:16:26 +0900

prjtrellis (1.4-1) unstable; urgency=medium

  * Initial release. (Closes: #1037506)

 -- Daniel Gröber <dxld@darkboxed.org>  Tue, 13 Jun 2023 18:08:53 +0200
