=== debian/control ===
Source: prjtrellis
Priority: optional
Section: electronics
Maintainer: Debian Electronics Team <pkg-electronics-devel@lists.alioth.debian.org>
Uploaders: Daniel Gröber <dxld@darkboxed.org>
Build-Depends:
 debhelper-compat (= 13),
 dh-python,
 cmake,
 python3-dev,
 help2man,
 libboost-thread-dev,
 libboost-filesystem-dev,
 libboost-program-options-dev
Standards-Version: 4.6.2
Homepage: https://github.com/YosysHQ/prjtrellis
Vcs-Browser: https://salsa.debian.org/electronics-team/prjtrellis
Vcs-Git: https://salsa.debian.org/electronics-team/prjtrellis.git
Rules-Requires-Root: no
Description: Lattice ECP5 FPGA bitstream tools and documentation
 Project Trellis provides documentation and tools for the bitstream used by
 Lattice ECP5 series FPGAs.

Package: python3-pytrellis
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ${python3:Depends},
 python3,
 fpga-trellis-database
Description: Library for interacting with Lattice ECP5 FPGA bitstreams
 ${source:Extended-Description}
 .
 This package contains the Python library.

Package: fpga-trellis-database
Architecture: all
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Lattice ECP5 FPGA bitstream database
 ${source:Extended-Description}
 .
 This package contains the machine readable bitstream descriptions.

Package: fpga-trellis
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends},
 fpga-trellis-database
Description: Tools for interacting with Lattice ECP5 FPGA bitstreams
 ${source:Extended-Description}
 .
 This package contains tools for producing and analyzing bitstreams.
